use rust_qt_binding_generator::*;
use std::path::PathBuf;

fn main()
{
   let out_dir = PathBuf::from(std::env::var("OUT_DIR").unwrap());

   let mut config = configuration::parse("bindings.json").unwrap();

   config.overwrite_implementation = true;
   config.cpp_file = out_dir.join("bindings.cc");
   config.rust.dir = out_dir;

   generate_bindings(&config).unwrap();

   let mut config = cmake::Config::new(".");

   if cfg!(debug_assertions) {
      config.cxxflag("-DTYCHO_DEBUG_ASSERTIONS");
   }

   let out_dir = config.build();
   let lib_dir = out_dir.join("lib");

   println!("cargo:rustc-link-search=native={}", lib_dir.display());
   println!("cargo:rustc-link-lib=static=maraiah-tycho-hermes");
   println!("cargo:rustc-link-lib=dylib=Qt5Core");
   println!("cargo:rustc-link-lib=dylib=Qt5Widgets");
   println!("cargo:rustc-link-lib=dylib=Qt5Gui");
   println!("cargo:rustc-link-lib=dylib=stdc++");
}

// EOF
